Index: main/plugin-syndication/src/org/ametys/plugins/syndication/FeedsGenerator.java
===================================================================
--- main/plugin-syndication/src/org/ametys/plugins/syndication/FeedsGenerator.java	(revision 0)
+++ main/plugin-syndication/src/org/ametys/plugins/syndication/FeedsGenerator.java	(revision 0)
@@ -0,0 +1,448 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.syndication;
+
+import java.io.IOException;
+import java.io.UnsupportedEncodingException;
+import java.net.URLDecoder;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.components.source.impl.SitemapSource;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.collections.CollectionUtils;
+import org.apache.commons.lang.StringUtils;
+import org.apache.excalibur.source.SourceResolver;
+import org.xml.sax.SAXException;
+
+import org.ametys.plugins.repository.metadata.CompositeMetadata;
+import org.ametys.runtime.group.GroupsManager;
+import org.ametys.runtime.plugins.core.userpref.UserPreferencesException;
+import org.ametys.runtime.plugins.core.userpref.UserPreferencesManager;
+import org.ametys.runtime.util.IgnoreRootHandler;
+import org.ametys.web.WebConstants;
+import org.ametys.web.pageaccess.PageAccessManager;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.repository.page.ZoneItem;
+import org.ametys.web.userpref.FOUserPreferencesConstants;
+
+/**
+ * Generator for feeds service
+ */
+public class FeedsGenerator extends ServiceableGenerator
+{
+    /** User pref key for urls */
+    public static final String USER_PREF_RSS_URL_KEY = "user-pref-rss-urls";
+    
+    /** User pref key for positions */
+    public static final String USER_PREF_RSS_POSITION_KEY = "user-pref-rss-positions";
+    
+    private static HashMap<String, Integer> _lifeTimes = new HashMap<String, Integer>();
+    static 
+    {
+        _lifeTimes.put("1", 1440);
+        _lifeTimes.put("2", 180);
+        _lifeTimes.put("3", 30);     
+    }
+    
+    /** Conf access component */
+    protected ConfAccessComponent _confAccess;
+    
+    /** The page access manager */
+    protected PageAccessManager _accessManager;
+    
+    /** The group manager */
+    protected GroupsManager _groupManager;
+    
+    /** The feed cache */
+    protected FeedCache _feedCache;
+    
+    /** The source resolver */
+    protected SourceResolver _resolver;
+    
+    /** The user preferences manager. */
+    protected UserPreferencesManager _userPrefManager;
+    
+    /** The rendering context handler. */
+    protected RenderingContextHandler _renderingContext;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _resolver = (SourceResolver) serviceManager.lookup(SourceResolver.ROLE);
+        _feedCache = (FeedCache) serviceManager.lookup(FeedCache.ROLE);
+        _accessManager = (PageAccessManager) serviceManager.lookup(PageAccessManager.ROLE);
+        _groupManager = (GroupsManager) serviceManager.lookup(GroupsManager.ROLE + ".FO");
+        _userPrefManager = (UserPreferencesManager) serviceManager.lookup(UserPreferencesManager.ROLE + ".FO");
+        _renderingContext = (RenderingContextHandler) serviceManager.lookup(RenderingContextHandler.ROLE);
+        _confAccess = (ConfAccessComponent) serviceManager.lookup(ConfAccessComponent.ROLE);
+    }
+    
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        
+        ZoneItem zoneItem = (ZoneItem) request.getAttribute(ZoneItem.class.getName());
+        String login = (String) request.getAttribute(WebConstants.FO_LOGIN);
+        
+        Page page = zoneItem.getZone().getPage();
+        String siteName = page.getSiteName();
+        String lang = page.getSitemapName();
+        
+        String storageContext = siteName + "/" + lang + "/" + zoneItem.getId();
+        Map<String, String> contextVars = _getContextVars(siteName, lang);
+        
+        CompositeMetadata serviceParameters = zoneItem.getServiceParameters();
+
+        List<String> urlList = new ArrayList<String>();
+        List<String> positionList = new ArrayList<String>();
+        try
+        {
+            urlList = _getListUrl(login, storageContext, contextVars);
+            positionList = _getListPosition(login, storageContext, contextVars);
+        }
+        catch (UserPreferencesException e1)
+        {
+            getLogger().error("Can't have the user preference from user : '" + login + "'");
+        }
+        
+        contentHandler.startDocument();
+        _saxAllFeed(request, zoneItem, serviceParameters, urlList, positionList);
+        contentHandler.endDocument();
+    }
+    
+    // Sax all the feed depend on the service parameters
+    private void _saxAllFeed(Request request, ZoneItem zoneItem, CompositeMetadata serviceParameters, List<String> urlList, List<String> userSelectedFeedsPositions) throws SAXException
+    {
+        String defaultLengthValueAsString = serviceParameters.getString("length");
+        if (StringUtils.isEmpty(defaultLengthValueAsString))
+        {
+            defaultLengthValueAsString = "-1";
+        }
+        String defaultLifeTime = serviceParameters.getString("cache");
+
+        AttributesImpl atts = new AttributesImpl();
+
+        CompositeMetadata rssFeeds = serviceParameters.getCompositeMetadata("feeds");
+        List<CompositeMetadata> listFeeds = _filterAndPreloadCacheMetadata(request, rssFeeds);
+
+        String nbMaxFeedFullSaxedAsString = serviceParameters.getString("nb-feed-max");
+        if (StringUtils.isEmpty(nbMaxFeedFullSaxedAsString))
+        {
+            nbMaxFeedFullSaxedAsString = "0";
+        }
+        long nbMaxFeedFullSaxed = Long.parseLong(nbMaxFeedFullSaxedAsString);
+        
+        String nbMaxUserAsString = serviceParameters.getString("nb-feed-user");
+        if (StringUtils.isEmpty(nbMaxUserAsString))
+        {
+            nbMaxUserAsString = "0";
+        }
+        long nbMaxUser = Long.parseLong(nbMaxUserAsString);
+        
+        atts.addCDATAAttribute("nbFeedService", String.valueOf(listFeeds.size()));
+        atts.addCDATAAttribute("zoneItemId", String.valueOf(zoneItem.getId()));
+        atts.addCDATAAttribute("nbMaxUser", String.valueOf(nbMaxUser));
+        atts.addCDATAAttribute("nbMax", String.valueOf(nbMaxFeedFullSaxed));
+        
+        Page page = (Page) request.getAttribute(Page.class.getName());
+        atts.addCDATAAttribute("showForm", String.valueOf(_confAccess.showPreferenceForm(page, nbMaxUserAsString, listFeeds.size(), nbMaxFeedFullSaxed)));
+        
+        XMLUtils.startElement(contentHandler, "rssFeeds", atts);
+        
+        long totalFeed = listFeeds.size() + nbMaxUser;
+        
+        _saxFeeds(totalFeed, listFeeds, urlList, nbMaxFeedFullSaxed, defaultLengthValueAsString, defaultLifeTime, serviceParameters, userSelectedFeedsPositions);
+        _saxFeedsConfig(totalFeed, nbMaxUser, listFeeds, urlList, userSelectedFeedsPositions);
+        
+        XMLUtils.endElement(contentHandler, "rssFeeds");
+    }
+    
+    private void _saxFeedsConfig(long totalFeed, long nbMaxUser, List<CompositeMetadata> listFeeds, List<String> urlList, List<String> userSelectedFeedsPositions) throws SAXException
+    {
+        int nbFeedCustom = 0;
+        for (int position = 0; position < totalFeed; position++)
+        {
+            CompositeMetadata rssFeed = null;
+            if (position < listFeeds.size())
+            {
+                rssFeed = listFeeds.get(position);
+            }
+            
+            Boolean isCheck = userSelectedFeedsPositions.contains(String.valueOf(position + 1));
+
+            if (rssFeed != null) // Feed from service parameters
+            {
+                _saxInfoFeed(rssFeed.getString("url"), rssFeed.getString("title"), false, isCheck); // Sax the user preference form
+            }
+            else // Feed from user preference
+            {
+                if (position - listFeeds.size() < urlList.size())
+                {
+                    _saxInfoFeed(urlList.get(position - listFeeds.size()), "", true, isCheck); // Sax the user preference form
+                }
+                else if (nbFeedCustom < nbMaxUser)
+                {
+                    _saxInfoFeed("", "", true, isCheck); // Sax the user preference form (empty input)
+                }
+                nbFeedCustom++;
+            }
+        }
+    }
+    
+    private void _saxFeeds(long totalFeed, List<CompositeMetadata> listFeeds, List<String> urlList, long nbMaxFeedFullSaxed, String defaultLengthValueAsString, String defaultLifeTime, CompositeMetadata serviceParameters,  List<String> userSelectedFeedsPositions)
+    {
+        int nbFeedFullSaxed = 0;
+        for (int position = 0; position < totalFeed; position++)
+        {
+            CompositeMetadata rssFeed = null;
+            if (position < listFeeds.size())
+            {
+                rssFeed = listFeeds.get(position);
+            }
+            
+            // Check if the max number of feed to sax was not reached
+            // and if the feed has been selected by the visitor
+            if ((nbFeedFullSaxed < nbMaxFeedFullSaxed || nbMaxFeedFullSaxed == 0)
+                && (userSelectedFeedsPositions.isEmpty() || userSelectedFeedsPositions.contains(String.valueOf(position + 1))))
+            {
+                if (rssFeed != null) // Feed from service parameters
+                {
+                    Boolean isCheck = userSelectedFeedsPositions.contains(String.valueOf(position + 1));
+
+                    _saxFullInfoFeed(rssFeed, isCheck, defaultLengthValueAsString, defaultLifeTime); // Sax all informations
+                }
+                else // Feed from user preference
+                {
+                    if (position - listFeeds.size() < urlList.size())
+                    {
+                        String urlFeed = urlList.get(position - listFeeds.size());
+                        Boolean isCheck = userSelectedFeedsPositions.contains(String.valueOf(position + 1));
+                        
+                        _saxFullInfoFeedCustom(serviceParameters, urlFeed, defaultLengthValueAsString, isCheck); // Sax all informations
+                    }
+                }
+                nbFeedFullSaxed++;
+            }
+        }
+    }
+    
+    // Sax few info from the feed for the user preference form
+    private void _saxInfoFeed(String url, String name, Boolean isCustom, Boolean isCheck) throws SAXException
+    {
+        AttributesImpl atts = new AttributesImpl();
+
+        atts.addCDATAAttribute("feedUrl", url);
+        atts.addCDATAAttribute("feedName", name);
+        atts.addCDATAAttribute("isCustom", String.valueOf(isCustom));
+        atts.addCDATAAttribute("isCheck", String.valueOf(isCheck));
+
+        XMLUtils.createElement(contentHandler, "feed-conf", atts);
+    }
+    
+    // Sax all info from the feed for the service (Feed from service parameters)
+    private void _saxFullInfoFeed(CompositeMetadata rssFeed, Boolean isCheck, String defaultLengthValueAsString, String defaultLifeTime)
+    {
+        String nbItemsAsString = rssFeed.getString("length");
+        if (StringUtils.isEmpty(nbItemsAsString))
+        {
+            nbItemsAsString = defaultLengthValueAsString;
+        }
+        long nbItems = Long.parseLong(nbItemsAsString);
+        String lifeTime = rssFeed.getString("cache", defaultLifeTime);
+        String url = rssFeed.getString("url");
+        String name = rssFeed.getString("title");
+        
+        _callFeedGenerator(nbItems, url, name, lifeTime, false, isCheck);
+    }
+    
+    // Sax all info from the feed for the service (Feed from user preference)
+    private void _saxFullInfoFeedCustom(CompositeMetadata serviceParameters, String url, String defaultLengthValueAsString, Boolean isCheck)
+    {
+        String lifeTime = serviceParameters.getString("cache");
+        _callFeedGenerator(Long.parseLong(defaultLengthValueAsString), url, "", lifeTime, true, isCheck);
+    }
+    
+    // Call the pipeline to sax all information from a feed
+    private void _callFeedGenerator(long length, String url, String name, String lifeTime, Boolean isCustom, Boolean isCheck)
+    {
+        SitemapSource sitemapSource = null;
+        try
+        {
+            HashMap<String, Object> parameter = new HashMap<String, Object>();
+            parameter.put("length", length);
+            parameter.put("url", url);
+            parameter.put("name", name);
+            parameter.put("cache", _lifeTimes.get(lifeTime));
+            parameter.put("isCustom", isCustom);
+            parameter.put("isCheck", isCheck);
+            
+            sitemapSource = (SitemapSource) _resolver.resolveURI("cocoon:/feed", null, parameter);
+            sitemapSource.toSAX(new IgnoreRootHandler(contentHandler));
+        }
+        catch (Exception e)
+        {
+            getLogger().error("There is an error in the flux : '" + url + "'");
+        }
+        finally
+        {
+            _resolver.release(sitemapSource);
+        }
+    }
+    
+    // Get the list of url from the user preferences
+    private List<String> _getListUrl(String login, String storageContext, Map<String, String> contextVars) throws UserPreferencesException, UnsupportedEncodingException
+    {
+        String urls = _userPrefManager.getUserPreferenceAsString(login, storageContext, contextVars, USER_PREF_RSS_URL_KEY);
+        List<String> urlAsList = new ArrayList<String>();
+        if (StringUtils.isNotEmpty(urls))
+        {
+            String[] urlsAsArray = StringUtils.split(urls, ",");
+            for (String url : urlsAsArray)
+            {
+                urlAsList.add(URLDecoder.decode(url, "utf-8"));
+            }
+        }
+          
+        return urlAsList;
+    }
+    
+    // Get the list of chosen feed (position) from the user preferences
+    private List<String> _getListPosition(String login, String storageContext, Map<String, String> contextVars) throws UserPreferencesException
+    {
+        String positions = _userPrefManager.getUserPreferenceAsString(login, storageContext, contextVars, USER_PREF_RSS_POSITION_KEY);
+        if (StringUtils.isNotEmpty(positions))
+        {
+            String[] positionsAsArray = StringUtils.split(positions, ",");
+            return Arrays.asList(positionsAsArray);
+        }
+        
+        return new ArrayList<String>();
+    }
+    
+    // prefilter before sax the feeds
+    private List<CompositeMetadata> _filterAndPreloadCacheMetadata(Request request, CompositeMetadata rssFeeds)
+    {
+        List<CompositeMetadata> listFeeds = new ArrayList<CompositeMetadata>();
+        
+        String[] metadataNames = rssFeeds.getMetadataNames();
+        Arrays.sort(metadataNames, new Comparator<String>() {
+            public int compare(String o1, String o2)
+            {
+                return Integer.parseInt(o1) - Integer.parseInt(o2);
+            }
+        });
+        
+        for (String name : metadataNames)
+        {
+            CompositeMetadata rssFeed = rssFeeds.getCompositeMetadata(name);
+
+            Boolean access = _checkUserAccessRSS(request, rssFeed);
+            if (access)
+            {
+                listFeeds.add(rssFeed);
+            }
+        }
+        
+        return listFeeds;
+    }
+
+    // Check if the user can access to the feed
+    private boolean _checkUserAccessRSS(Request request, CompositeMetadata rssFeed)
+    {
+        if (_renderingContext.getRenderingContext() == RenderingContext.FRONT)
+        {
+            Page page = (Page) request.getAttribute(Page.class.getName());
+            
+            String login = (String) request.getAttribute(WebConstants.FO_LOGIN);
+            
+            String foGroup = rssFeed.getString("fo-group");
+            String foUser = rssFeed.getString("fo-user");
+            Boolean limited = rssFeed.getBoolean("limited");
+            if (limited)
+            {
+                if (page == null)
+                {
+                    return false;
+                }
+                return _accessManager.getAccessInfo(page).isRestricted();
+            }
+            else 
+            {
+                if (login == null)
+                {
+                    return false;
+                }
+                
+                if (StringUtils.isEmpty(foUser) && StringUtils.isEmpty(foGroup))
+                {
+                    return true;
+                }
+                
+                List<String> userList = new ArrayList<String>();
+                if (StringUtils.isNotEmpty(foUser))
+                {
+                    userList = Arrays.asList(StringUtils.split(foUser, ","));
+                    if (userList.contains(login))
+                    {
+                        return userList.contains(login);
+                    }
+                }
+                
+                if (StringUtils.isNotEmpty(foGroup))
+                {
+                    for (String group : StringUtils.split(foGroup, ","))
+                    {
+                        if (_groupManager.getGroup(group).getUsers().contains(login))
+                        {
+                            return true;
+                        }
+                        
+                    }
+                }
+                
+                return false;
+            }
+        }
+        return true;
+    }
+    
+    private Map<String, String> _getContextVars(String siteName, String language)
+    {
+        Map<String, String> contextVars = new HashMap<String, String>();
+        
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_SITENAME, siteName);
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_LANGUAGE, language);
+        
+        return contextVars;
+    }
+}
+
+
Index: main/plugin-syndication/src/org/ametys/plugins/syndication/CreateUserConfAction.java
===================================================================
--- main/plugin-syndication/src/org/ametys/plugins/syndication/CreateUserConfAction.java	(revision 0)
+++ main/plugin-syndication/src/org/ametys/plugins/syndication/CreateUserConfAction.java	(revision 0)
@@ -0,0 +1,152 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.syndication;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.acting.ServiceableAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.runtime.plugins.core.userpref.UserPreferencesManager;
+import org.ametys.runtime.util.I18nizableText;
+import org.ametys.runtime.util.URLEncoder;
+import org.ametys.runtime.util.cocoon.ActionResultGenerator;
+import org.ametys.web.WebConstants;
+import org.ametys.web.repository.page.Page;
+import org.ametys.web.repository.page.ZoneItem;
+import org.ametys.web.userpref.FOUserPreferencesConstants;
+
+
+/**
+ * Set user preference
+ */
+public class CreateUserConfAction extends ServiceableAction
+{
+    /** The user preferences manager. */
+    protected UserPreferencesManager _userPrefManager;
+    
+    /** The Ametys resolver */
+    protected AmetysObjectResolver _resolver;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _userPrefManager = (UserPreferencesManager) serviceManager.lookup(UserPreferencesManager.ROLE + ".FO");
+        _resolver = (AmetysObjectResolver) serviceManager.lookup(AmetysObjectResolver.ROLE);
+    }
+    
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        Map<String, Object> result = new HashMap<String, Object>();
+        List<I18nizableText> errors = new ArrayList<I18nizableText>();
+
+        String login = (String) request.getAttribute(WebConstants.FO_LOGIN);
+        
+        String zoneItemId = request.getParameter("zone-item-id");
+        ZoneItem zoneItem = _resolver.resolveById(zoneItemId);
+   
+        Page page = zoneItem.getZone().getPage();
+        String language = page.getSitemapName();
+        String siteName = page.getSiteName();
+        
+        String storageContext = siteName + "/" + language + "/" + zoneItem.getId();
+        Map<String, String> contextVars = _getContextVars(siteName, language);
+        
+        Map<String, String> values = new HashMap<String, String>();
+        String positions = _getPositions(request);
+        
+        int nbMaxCheck = Integer.parseInt(request.getParameter("nbMaxCheck"));
+        if (StringUtils.split(positions, ",").length <= nbMaxCheck || nbMaxCheck == 0)
+        {
+            values.put(FeedsGenerator.USER_PREF_RSS_POSITION_KEY, _getPositions(request));
+            values.put(FeedsGenerator.USER_PREF_RSS_URL_KEY, _getUrls(request));
+            
+            _userPrefManager.setUserPreferences(login, storageContext, contextVars, values);
+        }
+        else
+        {
+            errors.add(new I18nizableText("plugin.syndication", "SYNDICATION_SERVICE_CONFIG_RSS_ERROR_TO_MANY_CHECK"));
+        }
+        
+        result.put("error", errors);
+        
+        request.setAttribute(ActionResultGenerator.MAP_REQUEST_ATTR, result);
+        
+        return EMPTY_MAP;
+    }
+    
+    private String _getUrls(Request request)
+    {
+        int nbFeedUser = Integer.parseInt(request.getParameter("nbMaxUser"));
+
+        int nbFeed = Integer.parseInt(request.getParameter("nbFeedService"));
+        int position = nbFeed + 1;
+        
+        List<String> urls = new ArrayList<String>();
+        for (int i = 0; i < nbFeedUser; i++)
+        {
+            String url = request.getParameter("feed-url-" + (position + i));
+            urls.add(URLEncoder.encode(url));
+        }
+        
+        return StringUtils.join(urls, ",");
+    }
+    
+    private String _getPositions(Request request)
+    {
+        int nbFeed = Integer.parseInt(request.getParameter("nbFeedService"));
+        int nbFeedUser = Integer.parseInt(request.getParameter("nbMaxUser"));
+
+        List<Integer> positions = new ArrayList<Integer>();
+        for (int i = 1; i <= (nbFeed + nbFeedUser); i++)
+        {
+            String checked = request.getParameter("feed-check-" + i);
+            if (!StringUtils.isEmpty(checked))
+            {
+                if (checked.equals("true") || checked.equals("on"))
+                {
+                    positions.add(i);
+                }
+            }
+        }
+        
+        return StringUtils.join(positions, ",");
+    }
+    
+    private Map<String, String> _getContextVars(String siteName, String language)
+    {
+        Map<String, String> contextVars = new HashMap<String, String>();
+        
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_SITENAME, siteName);
+        contextVars.put(FOUserPreferencesConstants.CONTEXT_VAR_LANGUAGE, language);
+        
+        return contextVars;
+    }
+
+}
Index: main/plugin-syndication/src/org/ametys/plugins/syndication/ConfAccessComponent.java
===================================================================
--- main/plugin-syndication/src/org/ametys/plugins/syndication/ConfAccessComponent.java	(revision 0)
+++ main/plugin-syndication/src/org/ametys/plugins/syndication/ConfAccessComponent.java	(revision 0)
@@ -0,0 +1,120 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.syndication;
+
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.plugins.repository.metadata.CompositeMetadata;
+import org.ametys.plugins.repository.metadata.CompositeMetadata.MetadataType;
+import org.ametys.web.pageaccess.PageAccessManager;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
+import org.ametys.web.repository.page.Page;
+
+
+/**
+ *  Component for access to the user configuration for feeds
+ */
+public class ConfAccessComponent implements Component, Serviceable
+{
+    /** Avalon ROLE. */
+    public static final String ROLE = ConfAccessComponent.class.getName();
+ 
+    /** The page access manager */
+    protected PageAccessManager _accessManager;
+    
+    /** The rendering context handler. */
+    protected RenderingContextHandler _renderingContext;
+    
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        _accessManager = (PageAccessManager) manager.lookup(PageAccessManager.ROLE);
+        _renderingContext = (RenderingContextHandler) manager.lookup(RenderingContextHandler.ROLE);
+
+    }
+    
+    /**
+     * Say if the preference forms for RSS Feeds is showed
+     * @param page
+     * @param nbFeedPerso
+     * @param nbFeeds
+     * @param nbMaxFeed
+     * @return true if the preference forms for RSS Feeds is showed
+     */
+    public boolean showPreferenceForm(Page page, String nbFeedPerso, long nbFeeds, long nbMaxFeed)
+    {
+        if (_renderingContext.getRenderingContext() == RenderingContext.FRONT)
+        {
+            if (page == null)
+            {
+                return false;
+            }
+            
+            return _accessManager.getAccessInfo(page).isRestricted() && _hasCustomsFeeds(nbFeedPerso, nbFeeds, nbMaxFeed);
+        }
+        
+        return false;
+    }
+
+    /**
+     * Check if the service for feeds is cacheable
+     * @param repeater
+     * @param nbFeedPerso
+     * @param nbFeeds
+     * @param nbMaxFeed
+     * @return true if the service is Cacheable
+     */
+    public boolean isServiceCacheable(CompositeMetadata repeater, String nbFeedPerso, int nbFeeds, int nbMaxFeed)
+    {
+        for (String name : repeater.getMetadataNames())
+        {
+            if (repeater.getType(name) == MetadataType.COMPOSITE)
+            {
+                CompositeMetadata feed = repeater.getCompositeMetadata(name);
+                Boolean limited = feed.getBoolean("limited");
+                String foUser = feed.getString("fo-user");
+                String foGroup = feed.getString("fo-group");
+                
+                if (limited || StringUtils.isNotEmpty(foUser) || StringUtils.isNotEmpty(foGroup))
+                {
+                    return false;
+                }
+            }
+        }
+        
+        return !_hasCustomsFeeds(nbFeedPerso, nbFeeds, nbMaxFeed);
+    }
+    
+    private boolean _hasCustomsFeeds(String nbFeedPerso, long nbFeeds, long nbMaxFeed)
+    {
+        if (StringUtils.isNotEmpty(nbFeedPerso) && Integer.parseInt(nbFeedPerso) != 0)
+        {
+            return true;
+        }
+        
+        if (nbMaxFeed < nbFeeds)
+        {
+            return true;
+        }
+        
+        return false;
+    }
+}
+
